#ifndef __CUBE_H__
#define __CUBE_H__

#include <GL/glu.h>


namespace oglclass
{
enum cubeType {CUBE_WIREFRAME, CUBE_SOLID, CUBE_TRANSPARENT, CUBE_TEXTURE, CUBE_TEXTURE_TRANSPARENT};

class cube
{
public:
    cube(float w=1.0, float h=1.0, float l=1.0);
    ~cube(void);
    void draw();

	void setDrawType(cubeType type = CUBE_WIREFRAME) { type_ = type; };
	void setTextureIndex(GLuint index = 0) { textureIndex_ = index; };
	void initTexture(char *filename, GLfloat wrap = GL_REPEAT);
    
private:
	float vertex_[8][3];
	int index_[6][4];
	float normal_[6][3];
	float texture_[4][2];
	float width_, height_, length_;
	GLuint textureIndex_;
    cubeType type_;

	void makeCube();
	void drawWireframe();
	void drawSolid();
	void drawTransparent();
	void drawTexture();
	void drawTextureTransparent();
};

}

#endif
